(define (domain post)
  (:requirements :strips :typing)
  (:types robot location object office person)
  (:predicates (on-board ?o ?r) 
	       (at ?r ?l)
               (con ?m ?l) 
	       (has-fuel ?r)
               (has-key ?r ?off)
               (in-front ?m ?off) 
               (open ?off)
               (closed ?off)
	       (protocolled ?o)
               (has ?o ?p)
	       (at-RP ?r)
	       (at-MB ?r)
	       (has-key-MB ?off))


   (:action take-out 
	    :parameters (?o - object ?r - robot ?l - location)
	    :precondition (and (on-board ?o ?r) (at ?r ?l))
	    :effect (and (at ?o ?l) (not (on-board ?o ?r))))

   (:action put-in
	    :parameters (?o - object ?r - robot ?l - location)
	    :precondition (and (at ?o ?l) (at ?r ?l))
	    :effect (and (on-board ?o ?r) (not (at ?o ?l))))

   (:action move
	    :parameters  (?r - robot ?m - location ?l - location)
	    :precondition (and (at ?r ?m) (con ?m ?l) (has-fuel ?r))
	    :effect (and (at ?r ?l) (not (at ?r ?m))))

   (:action refuel
	    :parameters (?r - robot)
	    :precondition (and (at-RP ?r))
	    :effect (and (has-fuel ?r)))

   (:action open-office
	    :parameters (?r - robot  ?m - location ?off - office)
	    :precondition (and (at ?r ?m) (in-front ?m ?off) (closed ?off) (has-key ?r ?off))
	    :effect (and (open ?off) (not (closed ?off))))

   (:action close-office
	    :parameters (?r - robot  ?m - location ?off - office)
	    :precondition (and (at ?r ?m) (in-front ?m ?off) (open ?off) (has-key ?r ?off))
	    :effect (and (closed ?off) (not (open ?off))))

   (:action get-key
	    :parameters (?r - robot  ?off - office)
	    :precondition (and (at-MB ?r) (has-key-MB ?off))
	    :effect (and (has-key ?r ?off) (not (has-key-MB ?off))))

   (:action putdown-key
	    :parameters (?r - robot  ?off - office)
	    :precondition (and (at-MB ?r) (has-key ?r ?off))
	    :effect (and (has-key-MB ?off) (not (has-key ?r ?off))))

   (:action enter-office
	    :parameters (?r - robot  ?m - location ?off - office)
	    :precondition (and (at ?r ?m) (in-front ?m ?off) (open ?off))
	    :effect (and (at ?r ?off) (not (at ?r ?m))))

   (:action exit-office
	    :parameters (?r - robot ?off - office ?m - location)
	    :precondition (and (at ?r ?off) (in-front ?m ?off) (open ?off))
	    :effect (and (at ?r ?m) (not (at ?r ?off))))

   (:action give-obj
	    :parameters (?o - object ?r - robot ?p - person ?l - location)
	    :precondition (and (on-board ?o ?r) (at ?r ?l) (at ?p ?l))
	    :effect (and (has ?o ?p) (not (on-board ?o ?r))))

   (:action protocol-obj
	    :parameters (?o - object)
	    :precondition (and (at-MB ?o))
	    :effect (and (protocolled ?o))))

